local M = {}

local helper = require('scenario/scenariohelper')
local reset = true

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		reset = true
	end
end

local function onRaceWaypointReached(data)
	if data.vehicleName == 'scenario_player0' then
		if data.waypointName == 'WayPoint1' then
			helper.flashUiMessage('What appears in the mirror cube, but not in reality?', 5) 
		end
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'portal1B' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-61.1351 19.3631 26.6615";
		]])
	elseif data.triggerName == 'portal1A' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "131.325 -43.6588 76.7588";
		]])
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "23.7144 -50.2295 0.346309";
			scenario_player0.rotation = "0 0 1 180";
		]])
		reset = false
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onRaceWaypointReached = onRaceWaypointReached
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M