local M = {}

local helper = require('scenario/scenariohelper')
local reset = true

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		reset = true
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'portal1A' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "58.1407 13.9128 0.15";
		]])
	elseif data.triggerName == 'portal1B' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-60.5881 -16.9601 0.15";
		]])
	elseif data.triggerName == 'portal2A' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-59.0424 -42.1199 48.8658";
		]])
	elseif data.triggerName == 'portal2B' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "96.5312 -34.588 0.15";
		]])
	elseif data.triggerName == 'portal3A' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-23.8253 102.659 57.5844";
		]])
	elseif data.triggerName == 'portal3B' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-23.2633 -16.4501 57.6037";
		]])
	elseif data.triggerName == 'portal4A' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "128.764 -6.64432 68.1724";
		]])
	elseif data.triggerName == 'portal4B' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-57.3358 95.0426 67.7833";
		]])
	elseif data.triggerName == 'box1' and data.subjectName == 'key_box_1' then
		helper.flashUiMessage('Platform Moved!', 2)
		TorqueScript.eval([[
			door1.position = "-45.8622 -36.1955 43.9224";
			door1.rotation = "0 1 0 35.6636";
			key_box_1.position = "10000 0 0";
		]])
		be:reloadStaticCollision();
	elseif data.triggerName == 'box2' and data.subjectName == 'key_box_2' then
		helper.flashUiMessage('Platform Moved!', 2)
		TorqueScript.eval([[
			door2.position = "75.075 8.433 64.2062";
			door2.rotation = "0 1 0 26.6682";
			key_box_2.position = "10000 0 0";
		]])
		be:reloadStaticCollision();
	elseif data.triggerName == 'box3' and data.subjectName == 'key_box_3' then
		helper.flashUiMessage('Platform Moved!', 2)
		TorqueScript.eval([[
			door3.position = "92.9602 19.9892 74.0507";
			door3.rotation = "0 1 0 32.0941";
			key_box_3.position = "10000 0 0";
		]])
		be:reloadStaticCollision();
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "23.7144 -50.2295 0.346309";
			scenario_player0.rotation = "0 0 1 180";
			key_box_1.position = "86.0297 -7.28443 6.8754";
			key_box_1.rotation = "0 0 1 180";
			key_box_2.position = "16.3699 26.0004 28.3945";
			key_box_2.rotation = "0 0 1 180";
			key_box_3.position = "11.2051 92.6614 67.7908";
			key_box_3.rotation = "0 0 1 180";
			door1.position = "-58.0934 24.8231 78.206";
			door1.rotation = "1 0 0 0";
			door2.position = "86.5906 -7.48529 28.564";
			door2.rotation = "1 0 0 0";
			door3.position = "-24.9057 -7.51209 28.564";
			door3.rotation = "1 0 0 0";
		]])
		be:reloadStaticCollision();
		reset = false
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M