local M = {}

local helper = require('scenario/scenariohelper')
local reset = true
local boxes = 0

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		reset = true
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'portal1A' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "86.4508 -32.6924 25.455";
		]])
	elseif data.triggerName == 'portal1B' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-88.2398 -32.432 24.9662";
		]])
	elseif data.triggerName == 'portal2A' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-70.4099 -0.0578483 52.4048";
		]])
	elseif data.triggerName == 'portal2B' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-75.4332 1.38418 0.0906706";
		]])
	elseif data.triggerName == 'portal3A' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "87.0833 23.7711 65.9284";
		]])
	elseif data.triggerName == 'portal3B' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-87.4919 23.6342 65.7702";
		]])
	elseif data.triggerName == 'portal4A' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-84.9583 -20.6676 65.8185";
		]])
	elseif data.triggerName == 'portal4B' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "85.7349 -21.0343 65.9453";
		]])
	elseif data.triggerName == 'box1' then
		helper.flashUiMessage('Road Opened!', 2)
		TorqueScript.eval([[
			key_box_1.position = "10000 0 0";
			road1.position = "-44.4439 23.0976 51.2346";
			road1_5.position = "43.3983 22.6369 50.0005";
		]])
		be:reloadStaticCollision();
	elseif data.triggerName == 'box2' then
		helper.flashUiMessage('Road Opened!', 2)
		TorqueScript.eval([[
			key_box_2.position = "10000 0 0";
			road2.position = "44.7428 -21.6747 51.2346";
			road2_5.position = "-43.6937 -21.8104 49.9323";
		]])
		be:reloadStaticCollision();
	elseif data.triggerName == 'box3' then
		helper.flashUiMessage('Road Opened!', 2)
		TorqueScript.eval([[
			key_box_3.position = "10000 0 0";
			road3.position = "-29.4322 -21.9732 75.1416";
		]])
		be:reloadStaticCollision();
	elseif data.triggerName == 'box4' then
		helper.flashUiMessage('Doors Opened!', 2)
		TorqueScript.eval([[
			key_box_4.position = "10000 0 0";
			door.position = "10000 0 0";
			door.position = "10000 0 0";
		]])
		be:reloadStaticCollision();
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "-12.486 -39.9743 0.184686";
			scenario_player0.rotation = "0 0 1 180";
			
			key_box_1.position = "-33.5815 32.2006 24.233";
			key_box_1.rotation = "0 0 1 180";
			key_box_2.position = "32.0226 32.0151 24.1473";
			key_box_2.rotation = "0 0 1 180";
			key_box_3.position = "54.9913 22.3381 65.3705";
			key_box_3.rotation = "0 0 1 180";
			key_box_4.position = "-54.8415 -21.336 65.4093";
			key_box_4.rotation = "0 0 1 180";
			
			road1.position = "10000 0 0";
			road1_5.position = "10000 0 0";
			road2.position = "10000 0 0";
			road2_5.position = "10000 0 0";
			road3.position = "10000 0 0";
			road4.position = "10000 0 0";
			door2.position = "5.35127 -0.620927 50.8598";
			door.position = "-7.68701 -22.5923 97.6074";
		]])
		be:reloadStaticCollision();
		reset = false
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M