local M = {}

local helper = require('scenario/scenariohelper')
local reset = true
local boxes = 0

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		reset = true
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'portal1A' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-181.252 -36.4495 47.6568";
		]])
	elseif data.triggerName == 'portal1B' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-54.318 40.8262 29.2155";
		]])
	elseif data.triggerName == 'portal2A' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "4.80521-35.857 81.869";
		]])
	elseif data.triggerName == 'portal2B' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-131.144 40.5214 61.1635";
		]])
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "-12.486 -39.9743 0.184686";
			scenario_player0.rotation = "0 0 1 180";
		]])
		reset = false
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M