local M = {}

local helper = require('scenario/scenariohelper')
local reset = true
local converse = false
local continue = 1
local boxes = 0
local timer = 0

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		reset = true
		converse = false
		continue = 1
		timer = 0
	end
end

local function success(speed)
    local result = {msg = 'So, what\'s it going to be, test subject #15?'}
    scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'converse' then
		TorqueScript.eval([[
			scenario_player0.position = "-33.452 377.373 71.1845";
			scenario_player0.rotation = "0 0 1 180";
		]])
		local player = scenetree.findObject('scenario_player0')
        player:queueLuaCommand('scenario.freeze(1)')
		converse = true
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "-12.486 -39.9743 0.184686";
			scenario_player0.rotation = "0 0 1 180";
		]])
		reset = false
	end
	if converse then
		timer = timer+dt
		if continue == 1 and timer < 2 then
			ui_message('Hello', 2, 'A')
			continue = 2
		elseif continue == 2 and timer > 4 then
			ui_message('I think it was time we met fully', 4, 'B')
			continue = 3
		elseif continue == 3 and timer > 8 then
			ui_message('I don\'t believe we have been introduced', 4, 'C')
			continue = 4
		elseif continue == 4 and timer > 12 then
			ui_message('My name is test subject #55', 4, 'D')
			continue = 5
		elseif continue == 5 and timer > 16 then
			ui_message('I caused the explosion', 4, 'E')
			continue = 6
		elseif continue == 6 and timer > 20 then
			ui_message('Tell me, do you really think they can control portals and antimatter?', 8, 'F')
			continue = 7
		elseif continue == 7 and timer > 28 then
			ui_message('This is the reason I did this', 4, 'G')
			continue = 8
		elseif continue == 8 and timer > 32 then
			ui_message('We cannot control these powers', 4, 'H')
			continue = 9
		elseif continue == 9 and timer > 36 then
			ui_message('Bending reality and the fabric of space?', 4, 'I')
			continue = 10
		elseif continue == 10 and timer > 40 then
			ui_message('Sure, that CAN\'T go wrong, can it?', 4, 'J')
			continue = 11
		elseif continue == 11 and timer > 44 then
			ui_message('It\'s time to shut this place down, once and for all', 6, 'K')
			continue = 12
		elseif continue == 12 and timer > 50 then
			ui_message('It\'s your choice whether you agree with me or not', 6, 'L')
			continue = 13
		elseif continue == 13 and timer > 56 then
			ui_message('Either way, goodbye planet Earth, you were a nice planet', 6, 'M')
			continue = 14
		elseif continue == 14 and timer > 62 then
			ui_message('Just a shame that you inhabited such a power hungry species', 6, 'N')
			continue = 15
		elseif continue == 15 and timer > 68 then
			success(speed)
		end
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M